﻿using UnityEngine;
using System.Collections;

public enum TYPE
{
	TOURIST = 0,
	FATTY = 2,
	SKINNY = 1
}

public class Sacrifice : MonoBehaviour 
{
	public TYPE _type;

	private Rigidbody2D _rb;

	private bool _readyToEat;

	public int _multiplier;

	private int _kickPower = 50;

	public TYPE Type 
	{
		get { return _type; }

		set { _type = value; }
	}

	public delegate void OnMouth(bool state);
	public static event OnMouth OnMouthEvent;

	public delegate void DigestSacrifice(TYPE type);
	public static event DigestSacrifice DigestSacrificeEvent;

	// Use this for initialization
	void Start () 
	{
		//Physics2D.IgnoreCollision(this.GetComponent<Collider2D>(), this.GetComponent<
		//GameManager.EatSacrificeEvent += Eat;
		//_rb = GetComponent<Rigidbody2D>();
		//_rb.AddForce (new Vector2(50,0), ForceMode2D.Impulse);
	}

	public void KickOut(float kickPower)
	{
		_rb = GetComponent<Rigidbody2D>();
		_rb.AddForce (transform.right*kickPower, ForceMode2D.Force);
		Invoke ("OnBecameInvisible", 30f);
	}

	public void Eat()
	{
		if (_readyToEat) 
		{
			HardCodedAudioManager._instance.SwapClips (SFX.SCREAM);
			HardCodedAudioManager._instance.HardPlay (SFX.SCREAM);

			switch (_type) 
			{
				case TYPE.FATTY:
				case TYPE.SKINNY:
				GameManager._instance.UpdatePoints ((int)_type * _multiplier);
					break;
				case TYPE.TOURIST:
					GameManager._instance.DecrementLifes ();
					break;
				default:
					break;	
			}
				
			OnMouthEvent (false);
			GameObject.Destroy (this.gameObject);
		}
	}
		
	void OnTriggerStay2D(Collider2D collision)
	{
		if (collision.tag == "GOD")
		{
			_readyToEat = true;
			OnMouthEvent (true);
		}
	}

	void OnTriggerExit2D(Collider2D collision)
	{
		if (collision.tag == "GOD")
		{
			_readyToEat = false;
			OnMouthEvent (false);
			switch (_type) 
			{
				case TYPE.FATTY:
				case TYPE.SKINNY:
					GameManager._instance.DecrementLifes ();
					break;
				default:
					break;
			}
		}
	}

	void OnCollisionEnter2D(Collision2D collision)
	{
		Debug.Log ("Colidi");
	}

	void OnBecameInvisible()
	{
		GameObject.Destroy (this.gameObject);
	}
		
	// Update is called once per frame
	void Update () {}
}